<template>
  <section class="p-6 my-4 max-w-sm mx-auto bg-gray-200 dark:bg-gray-700 rounded-xl shadow-md flex items-center space-x-4">
    <router-link :to="searchLink" class="flex flex-row items-center flex-auto text-lg font-medium w-full">
      <slot class="flex-1"></slot>
    </router-link>
    <button aria-label="Marcar búsqueda reciente como favorita" @click="onClick">
      <font-awesome-icon
        title="Buscar"
        class="fill-current text-yellow-400"
        :icon="[recentSearch.faved ? 'fas' : 'far', 'star']"
      />
    </button>
  </section>
</template>

<script lang="ts">
import { defineComponent, PropType } from 'vue';

// Types
import { RecentSearch } from '@/types/search-results.types';

export default defineComponent({
  name: 'RecentSearch',
  inheritAttrs: false,
  props: {
    searchLink: {
      type: String,
      required: true
    },
    recentSearch: {
      type: Object as PropType<RecentSearch>,
      required: true
    }
  },
  emits: {
    'on-fav-click'(payload: RecentSearch) {
      if ('id' in payload && 'query' in payload && 'faved' in payload) {
        return true;
      }

      return false;
    }
  },
  methods: {
    onClick() {
      this.$emit('on-fav-click', this.recentSearch);
    }
  }
});
</script>
